annotate test/test-server.sh @ 116:d15cb1151d76

Add JSON support directly to the server. Had hoped to avoid this (using Capnp as canonical in the server and then converting externally as necessary) but it's just too useful for debugging purposes when bundled with client app
author Chris Cannam <c.cannam@qmul.ac.uk>
date Thu, 27 Oct 2016 11:39:41 +0100
parents 81e1c48e97f9
children 5dffc5147176
rev   line source
c@75 1 #!/bin/bash
c@75 2
c@75 3 set -eu
c@75 4
c@75 5 piperdir=../piper
c@75 6 vampsdkdir=../vamp-plugin-sdk
c@75 7 schemadir="$piperdir"/json/schema
c@75 8
c@116 9 tmpdir=$(mktemp -d)
c@116 10
c@116 11 if [ ! -d "$tmpdir" ]; then
c@116 12 echo "Temp directory creation failed" 1>&2
c@116 13 exit 1
c@116 14 fi
c@116 15
c@116 16 trap "rm -rf $tmpdir" 0
c@116 17
c@116 18 reqfile="$tmpdir/req.json"
c@116 19 respfile="$tmpdir/resp.json"
c@116 20 allrespfile="$tmpdir/resp.all"
c@116 21 input="$tmpdir/input"
c@116 22 expected="$tmpdir/expected"
c@116 23 obtained="$tmpdir/obtained"
c@75 24
c@75 25 validate() {
c@75 26 local file="$1"
c@75 27 local schemaname="$2"
c@75 28 jsonschema -i "$file" "$schemadir/$schemaname.json" 1>&2 && \
c@75 29 echo "validated $schemaname" 1>&2 || \
c@75 30 echo "failed to validate $schemaname" 1>&2
c@75 31 }
c@75 32
c@75 33 validate_request() {
c@75 34 local json="$1"
c@75 35 echo "$json" > "$reqfile"
c@75 36 validate "$reqfile" "rpcrequest"
c@75 37 }
c@75 38
c@75 39 validate_response() {
c@75 40 local json="$1"
c@75 41 echo "$json" > "$respfile"
c@75 42 validate "$respfile" "rpcresponse"
c@75 43 }
c@75 44
c@116 45 cat > "$input" <<EOF
c@75 46 {"method":"list"}
c@75 47 {"method":"load","id":6,"params": {"key":"vamp-example-plugins:percussiononsets","inputSampleRate":44100,"adapterFlags":["AdaptInputDomain","AdaptBufferSize"]}}
c@75 48 {"method":"configure","id":"weevil","params":{"handle":1,"configuration":{"blockSize": 8, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 8}}}
c@75 49 {"method":"process","params": {"handle": 1, "processInput": { "timestamp": {"s": 0, "n": 0}, "inputBuffers": [ [1,2,3,4,5,6,7,8] ]}}}
c@75 50 {"method":"finish","params": {"handle": 1}}
c@75 51 EOF
c@75 52
c@75 53 # Expected output, apart from the plugin list which seems a bit
c@75 54 # fragile to check here
c@75 55 cat > "$expected" <<EOF
c@75 56 {"id": 6, "jsonrpc": "2.0", "method": "load", "result": {"defaultConfiguration": {"blockSize": 1024, "channelCount": 1, "parameterValues": {"sensitivity": 40, "threshold": 3}, "stepSize": 1024}, "handle": 1, "staticData": {"basic": {"description": "Detect percussive note onsets by identifying broadband energy rises", "identifier": "percussiononsets", "name": "Simple Percussion Onset Detector"}, "basicOutputInfo": [{"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}], "category": ["Time", "Onsets"], "copyright": "Code copyright 2006 Queen Mary, University of London, after Dan Barry et al 2005. Freely redistributable (BSD license)", "inputDomain": "TimeDomain", "key": "vamp-example-plugins:percussiononsets", "maker": "Vamp SDK Example Plugins", "maxChannelCount": 1, "minChannelCount": 1, "parameters": [{"basic": {"description": "Energy rise within a frequency bin necessary to count toward broadband total", "identifier": "threshold", "name": "Energy rise threshold"}, "defaultValue": 3, "extents": {"max": 20, "min": 0}, "unit": "dB", "valueNames": []}, {"basic": {"description": "Sensitivity of peak detector applied to broadband detection function", "identifier": "sensitivity", "name": "Sensitivity"}, "defaultValue": 40, "extents": {"max": 100, "min": 0}, "unit": "%", "valueNames": []}], "programs": [], "version": 2}}}
c@75 57 {"id": "weevil", "jsonrpc": "2.0", "method": "configure", "result": {"handle": 1, "outputList": [{"basic": {"description": "Percussive note onset locations", "identifier": "onsets", "name": "Onsets"}, "configured": {"binCount": 0, "binNames": [], "hasDuration": false, "sampleRate": 44100, "sampleType": "VariableSampleRate", "unit": ""}}, {"basic": {"description": "Broadband energy rise detection function", "identifier": "detectionfunction", "name": "Detection Function"}, "configured": {"binCount": 1, "binNames": [""], "hasDuration": false, "quantizeStep": 1, "sampleRate": 86.1328125, "sampleType": "FixedSampleRate", "unit": ""}}]}}
c@75 58 {"jsonrpc": "2.0", "method": "process", "result": {"features": {}, "handle": 1}}
c@75 59 {"jsonrpc": "2.0", "method": "finish", "result": {"features": {"detectionfunction": [{"featureValues": [0], "timestamp": {"n": 11609977, "s": 0}}]}, "handle": 1}}
c@75 60 EOF
c@75 61
c@116 62 # We run the whole test twice, once with the server in Capnp mode
c@116 63 # (converting to JSON using piper-convert) and once with it directly
c@116 64 # in JSON mode
c@75 65
c@116 66 for format in capnp json ; do
c@75 67
c@116 68 ( while read request ; do
c@116 69 validate_request "$request"
c@116 70 echo "$request"
c@116 71 done |
c@116 72 if [ "$format" = "json" ]; then
c@116 73 VAMP_PATH="$vampsdkdir"/examples bin/piper-vamp-server -d json
c@116 74 else
c@116 75 bin/piper-convert request -i json -o capnp |
c@116 76 VAMP_PATH="$vampsdkdir"/examples bin/piper-vamp-server -d capnp |
c@116 77 bin/piper-convert response -i capnp -o json
c@116 78 fi |
c@116 79 while read response ; do
c@116 80 echo "$response" >> "$allrespfile"
c@116 81 validate_response "$response"
c@116 82 done
c@116 83 ) < "$input"
c@116 84
c@116 85 # Skip plugin list
c@116 86 tail -n +2 "$allrespfile" > "$obtained"
c@116 87
c@116 88 echo "Checking response contents against expected contents..."
c@116 89 if ! cmp "$obtained" "$expected"; then
c@116 90 diff -u1 "$obtained" "$expected"
c@116 91 else
c@116 92 echo "OK"
c@116 93 fi
c@116 94
c@116 95 rm "$allrespfile"
c@116 96
c@116 97 done